// expandDlg.cpp : implementation file
//

#include "stdafx.h"
#include "expand.h"
#include "expandDlg.h"
#include "ido.h"
#include "entity.h"
#include "relation.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL


// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExpandDlg dialog

CExpandDlg::CExpandDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExpandDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExpandDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CExpandDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExpandDlg)
	DDX_Control(pDX, IDC_INTERACTCTRL1, m_IDO);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CExpandDlg, CDialog)
	//{{AFX_MSG_MAP(CExpandDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP

   ON_MESSAGE(UM_TOP, CreateTopDiagram)
   ON_MESSAGE(UM_OPEN, CreateOpenDiagram)

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExpandDlg message handlers

BOOL CExpandDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
   m_IDO.SetGridHeight(50);
   m_IDO.SetSnapToGrid(FALSE);
   CreateTopDiagram(0, 0L);


	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CExpandDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CExpandDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CExpandDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

LRESULT CExpandDlg::CreateTopDiagram(WPARAM wParam, LPARAM lParam)
{
   m_IDO.SetRedraw(FALSE);

   m_IDO.ResetDiagram();
   m_IDO.AddEntityFromClass(1, "", "Picture", "", 50, 50, 100, 100);
   m_IDO.AddEntityFromClass(3, "", "Text Class", "Click On the \'X\' To Expand", 200, 50, 100, 100);
   
   CEntity Entity;
   Entity = m_IDO.GetEntity(1, "");
   Entity.SetGraphic("A_Out.BMP");
   Entity.SetReadOnly(TRUE);

   Entity = m_IDO.GetEntity(1, "");
   Entity.SetReadOnly(TRUE);
   Entity.SetSelect(FALSE);

   m_IDO.SetRedraw(TRUE);

   return TRUE;
}

LRESULT CExpandDlg::CreateOpenDiagram(WPARAM wParam, LPARAM lParam)
{
   m_IDO.SetRedraw(FALSE);

   m_IDO.ResetDiagram();
   m_IDO.AddEntityFromClass(2, "", "Picture", "", 50, 50, 100, 100);
   
   CEntity Entity;
   Entity = m_IDO.GetEntity(2, "");
   Entity.SetGraphic("A_In.BMP");
   Entity.SetReadOnly(TRUE);

   m_IDO.AddEntityFromClass(5, "", "Text Class", "", 150, 0,  100, 30);
   Entity = m_IDO.GetEntity(5, "");
   Entity.SetText("Convey");
   Entity.SetReadOnly(TRUE);

   m_IDO.AddEntityFromClass(6, "", "Text Class", "", 150, 50, 100, 30);
   Entity = m_IDO.GetEntity(6, "");
   Entity.SetText("Ideas");
   Entity.SetReadOnly(TRUE);

   m_IDO.AddEntityFromClass(7, "", "Text Class", "", 150, 100, 100, 30);
   Entity = m_IDO.GetEntity(7, "");
   Entity.SetText("Visually");
   Entity.SetReadOnly(TRUE);
   Entity.SetSelect(FALSE);

   CRelation Relation;
   m_IDO.AddRelationFromClass(11, "", "Generic Relation", "", 5, "", 6, "");
//   Relation = m_IDO.GetRelation(11, "");
//   Relation.Repaint();

   m_IDO.AddRelationFromClass(13, "", "Generic Relation", "", 6, "", 7, "");
//   Relation = m_IDO.GetRelation(13, "");
//   Relation.Repaint();

   m_IDO.SetRedraw(TRUE);

   return TRUE;
}

BEGIN_EVENTSINK_MAP(CExpandDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CExpandDlg)
	ON_EVENT(CExpandDlg, IDC_INTERACTCTRL1, 21 /* ClickEntity */, OnClickEntityInteractctrl1, VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CExpandDlg::OnClickEntityInteractctrl1(long MouseStatus) 
{
   CEntity Entity;
   
   Entity = m_IDO.GetNotifyEntity();	
   if(Entity.UserID() == 1)
   {
      PostMessage(UM_OPEN, 0, 0L);
   }
   else
   {
      if(Entity.UserID() == 2)
      {
         PostMessage(UM_TOP, 0, 0L);
      }
   }

}
